/*
 * Copyright (c) 2020 Oracle and/or its affiliates. All rights reserved. This
 * code is released under a tri EPL/GPL/LGPL license. You can use it,
 * redistribute it and/or modify it under the terms of the:
 *
 * Eclipse Public License version 2.0, or
 * GNU General Public License version 2, or
 * GNU Lesser General Public License version 2.1.
 */
package org.truffleruby.language;

import com.oracle.truffle.api.interop.InteropLibrary;
import com.oracle.truffle.api.interop.TruffleObject;
import com.oracle.truffle.api.library.ExportLibrary;
import com.oracle.truffle.api.library.ExportMessage;

/** The Ruby {@code nil}, the single instance of NilClass. */
@ExportLibrary(InteropLibrary.class)
public final class Nil implements TruffleObject {

    public static final Nil INSTANCE = new Nil();

    private Nil() {
    }

    @ExportMessage
    protected boolean isNull() {
        return true;
    }

    @Override
    public String toString() {
        return "nil";
    }
}
